#ifndef _UNPALETTE_H_
#define _UNPALETTE_H_

/* $Id: unpalette.h,v 1.7 2002/09/28 16:00:35 dfx Exp $ */

/* The following macros define also
 * the index of the corresponding palette
 * in palettes[]
 */
#define CAMSOURCE_PALETTE_NONE	 	-1
#define CAMSOURCE_PALETTE_BGR24 	0
#define CAMSOURCE_PALETTE_RGB24 	1
#define CAMSOURCE_PALETTE_BGRA32 	2
#define CAMSOURCE_PALETTE_RGBA32 	3
#define CAMSOURCE_PALETTE_ABGR32 	4
#define CAMSOURCE_PALETTE_ARGB32 	5
#define CAMSOURCE_PALETTE_YUYV 		6
#define CAMSOURCE_PALETTE_YUV422	7
#define CAMSOURCE_PALETTE_RGB565	8
#define CAMSOURCE_PALETTE_RGB555	9
#define CAMSOURCE_PALETTE_YUV420P	10
#define CAMSOURCE_PALETTE_YUV420	11
#define CAMSOURCE_PALETTE_GREY 		12

struct image;

/* Converts an image from some palette into rgb24 format.
 * The image struct contains width and height of the image,
 * as well as a large enough output buffer.
 */
typedef void unpalettizer(struct image *, unsigned char *);

/* Array of all known palettes and their conversion routines */
struct palette
{
	int val;
	unpalettizer *routine;
	double bpp;	/* bytes per pixel, can be something like 1.5,
			 * in which case the number of input bytes must be
			 * a multiple of 2. */
	int depth;
	char *id;
	char *name;
};
extern struct palette palettes[];

/* TODO: make this extensible with plugins? */

#endif

